/*
 * Copyright (C) 2004 Oliver Horn
 *
 * You may use and modify this package for any purpose. Redistribution is
 * permitted, in both source and binary form, provided that this notice
 * remains intact in all source distributions of this package.
 */

package com.oliverh.xsltext.tokenizer;

import javax.xml.transform.TransformerException;

/**
 * @author Oliver Horn
 */
public interface TokenConsumer {

	public static final int KEYWORD = 1;
	
	public static final int LITERAL = 2;
	
	public static final int OPERATOR = 3;
	
	public static final int COMMENT = 4;
	
	public void startLine(int row) throws TransformerException;
	
	public void startToken(int type) throws TransformerException;
	
	public void characters(char[] buf, int index, int len) throws TransformerException;
	
	public void endToken(int type) throws TransformerException;
	
	public void endLine(int row) throws TransformerException;
}
