/*
 * Copyright (C) 2004 Oliver Horn
 *
 * You may use and modify this package for any purpose. Redistribution is
 * permitted, in both source and binary form, provided that this notice
 * remains intact in all source distributions of this package.
 */

package com.oliverh.xsltext.tokenizer;

import java.io.*;
import javax.xml.transform.TransformerException;
import org.jedit.syntax.*;

/**
 * @author Oliver Horn
 */
public abstract class Tokenizer {
		
	public static Tokenizer getTokenizer(String language) {
		Class clazz = null;
		try {
			try {
				clazz = Class.forName("org.jedit.syntax."+language+"TokenMarker");
			} catch (ClassNotFoundException e) {
				clazz = Class.forName(language+"TokenMarker");
			}
			return new JEditSyntaxTokenizer((TokenMarker)clazz.newInstance());
		} catch (Exception ex) {
		}		
		return null;
	}
	
	public void setTokenConsumer(TokenConsumer consumer) {
		this.consumer = consumer;
	}
	
	public TokenConsumer getTokenConsumer() {
		return consumer;
	}
	
	public abstract void tokenize(Reader in) throws IOException, TransformerException;
	
	private TokenConsumer consumer;	
}
