<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="xml"/>

<xsl:template match="/">
  <html>
    <head>
      <title>Test</title>
      <style type="text/css">
pre {
  border: dotted 1px #ccc;
  background-color: #eee;
}
.keyword, .operator {
  font-weight: bold;
  color: #66c;
}
.literal {
  color: #c66;
}
.comment {
  font-style: italic;
}
.lineno {
  font: x-small sans-serif;
  color: #999;
}
      </style>
    </head>
    <body>
      <xsl:apply-templates/>
    </body>
  </html>
</xsl:template>

<xsl:template match="listing" xmlns:syn="java:com.oliverh.xsltext.tokenizer.SaxonTokenizer">
  <xsl:variable name="syn" select="syn:tokenize(.,@language)"/>
  <pre>
    <xsl:apply-templates select="$syn/line" mode="syntax"/>
  </pre>
</xsl:template>

<xsl:template match="line" mode="syntax">
  <span class="lineno">
    <xsl:value-of select="format-number(position(),'000')"/>
    <xsl:text> </xsl:text>
  </span>
  <xsl:apply-templates mode="syntax"/>
  <xsl:text>&#xA;</xsl:text>
</xsl:template>

<xsl:template match="token" mode="syntax">
  <span class="{@class}">
    <xsl:apply-templates mode="syntax"/>
  </span>
</xsl:template>

</xsl:stylesheet>